function QiNiuUploader(params) {

	var mimeType = params.mime;
	if(!mimeType) {
		mimeType = "*/*";
	}

	if(!params) {
		console.error('指定参数');
		return;
	}

	if(!params.token) {
		console.error('指定token');
		return;
	}
	if(!params.browse_button_id) {
		console.error('指定按钮id');
		return;
	}
	if(!params.container) {
		container = 'container';
	}
	if(!params.drop_element) {
		drop_element = 'container';
	}

	function mimeChangedOnce() {
		document.getElementById(params.container).querySelector('input[type=file]').setAttribute('accept', mimeType);
		document.getElementById(params.container).removeEventListener('click', mimeChangedOnce);
	}

	document.getElementById(params.container).addEventListener('click', mimeChangedOnce);

	var uploader = Qiniu.uploader({
		runtimes: 'html5,flash,html4',
		browse_button: params.browse_button_id,
		container: params.container,
		drop_element: params.drop_element,
		max_file_size: '100mb',
		flash_swf_url: 'js/Moxie.swf',
		dragdrop: false,
		chunk_size: '4mb',
		uptoken: params.token,
		multi_selection: false,
		unique_names: true,
		domain: 'http://media.guohaozhongyi.com/',
		auto_start: false,
		init: {
			'FilesAdded': function(uploader, files) {
				if(params.onFilesAdd) {
					params.onFilesAdd(uploader, files);
				}
			},
			'BeforeUpload': function(uploader, files) {
				if(params.onBeforeUpload) {
					params.onBeforeUpload(uploader, files);
				}
			},
			'UploadProgress': function(uploader, file) {
				if(params.onUploadProgress) {
					params.onUploadProgress(uploader, file);
				}
			},
			'UploadComplete': function() {
				if(params.onUploadComplete) {
					params.onUploadComplete(uploader);
				}
			},
			'FileUploaded': function(uploader, file, info) {
				if(params.onFileUploaded) {
					params.onFileUploaded(uploader, file, info);
				}
			},
			'Error': function(uploader, err, errTip) {
				console.error('Error');
				console.error(errTip);

				if(params.onError) {
					params.onError(uploader, err, errTip);
				}
			}
		}
	});

	this.getUploader = function() {
		return uploader;
	}
}