mui.init();
var hotDoctorsList = new AdvancedList("#hotDoctorsList");
var hotClassesList = new AdvancedList("#hotClassesList");
hotDoctorsList.setItemTemplate("#hotDoctorsList>li:first-child");
hotClassesList.setItemTemplate("#hotClassesList>li:first-child");
var base = new BASE();
var cellIndex = 1;
var url = base.getBASEURL() + "appapi/1/class/index";
var profile = eval(window.localStorage.profile);
var modal = new Modal('#waiting');

//计算高度，自适应数量
var classPageSize;
var doctorsPageSize;
var headerHeight = 44;
var subTitleHeight = 35 * 2;
var pageHeight = document.documentElement.clientHeight;

pageHeight -= (headerHeight + subTitleHeight);
//	console.log("pageHeight="+pageHeight);

classPageSize = parseInt(pageHeight / 68);
//	console.log("classPageSize="+classPageSize);

classPageSize = doctorsPageSize = classPageSize / 2;

//固定
classPageSize = 8;
doctorsPageSize = 4;

var data = {
	classPageSize: parseInt(classPageSize),
	doctorsPageSize: Math.round(doctorsPageSize)
};

loadData();

function loadData() {
	modal.show();
	mui.ajax(url, {
		type: "GET",
		data: data,
		success: function(response) {
			if(base.getRUMTIME() == 1) {
				if(isAudit() == '1') {
					document.querySelector('.classMore').style.display = 'none';
					document.querySelector('.blog_index_introduction').style.display='none';
				}
			}
			hotClassesList.multipleAppend(response.obj.hotClasses);
			cellIndex = 1;
			hotDoctorsList.multipleAppend(response.obj.hotDoctors);
			modal.hide();
			window.parent.parent.refreshIframeHeight(document.body.clientHeight);
		},
		error: function(response) {
			mui.toast("获取数据失败！");
			modal.hide();
			document.getElementById('failed').style.display = 'initial';
		}
	});
}

function filterText(text) {
	if($(text).children().length > 0) {
		//HTML文本，筛选出文字
		var contentArr = text.match(/>.[^><]*</g);
		var content = '';
		for(var i in contentArr) {
			content += contentArr[i].substring(1, contentArr[i].length - 1);
		}
		return content.substr(0, 64).trim();
	} else {
		return text;
	}
}

hotClassesList.onCreateItem = function(data, item) {
	if(base.getRUMTIME() == 1) {
		if(isAudit() == '1' & data.price > 0) {
			return;
		}
	}
	if(data.onZego) {
		$(item).find('.class-live-state').removeClass('class-live-state-off').addClass('class-live-state-on');
	}
	item.id = data.id;
	item.style.display = "block";
	item.querySelector(".coverImg").src = data.coverImg + "?imageView2/1/w/65/h/65";
	item.querySelector(".class-title").innerHTML = data.title;
	item.querySelector(".description").innerHTML = filterText(data.description);
};
hotDoctorsList.onCreateItem = function(data, item) {
	item.id = data.userId;
	item.style.display = "block";
	item.querySelector('.doctor-icon').src = data.userFace + "?imageView2/1/w/65/h/65";
	item.querySelector('.userName').innerHTML = data.realName;
	item.querySelector(".remark").innerHTML = data.attending;
	item.userId = data.userId;
};

function scrolling() {
	var body = document.body;
	if(body.offsetHeight + 200 - window.innerHeight - body.scrollTop <= 0) pullDownRefresh();
}

function _jump(article) {
	openWindowInParent('KT_Introduction.html?id=' + article.id);
}

function _jumpDT(article) {
	openWindowInParent('doctor_blog.html?userId=' + article.userId);
}

function checkLogin() {
	var base = new BASE();
	var profile = localStorage.profile;
	if(!profile) {
		openWindowInParent('login.html');
		return;
	}
	profile = eval(profile);
	var tokenId = profile.tokenId;
	mui.ajax(
		base.getBASEURL() + 'appapi/1/user/checkLogin', {
			type: 'POST',
			data: {
				tokenId: tokenId
			},
			success: function(response) {
				if(response.success && response.errorCode == 1001) {
					switch(profile.vip) {
						case 0:
							mui.toast('请先认证成为咨询师');
							setTimeout(function() {
								openWindowInParent('QiNiu_Upload.html');
							}, 1500);

							break;
						case 1:
							openWindowInParent('DoctorMine_CreateClass.html');
							break;
						case 2:
							mui.toast('咨询师资格审核中，请通过后再开课');
							break;
						case 3:
							mui.toast('请先认证成为咨询师');
							setTimeout(function() {
								openWindowInParent('QiNiu_Upload.html');
							}, 1500);
					}
				} else {
					mui.toast(response.msg);
					openWindowInParent('login.html');
				}
			},
			error: function(response) {
				mui.toast('网络连接失败');
			}
		}
	);
}

function _jumpToCreate() {
	checkLogin();
}