mui.init();
window.onpageshow = function() {
	hideOrShowBtn();
}

function checkLogin() {
	var base = new BASE();
	var profile = localStorage.profile;
	if(!profile) {
		openWindowInParent('login.html');
		return;
	}
	profile = eval(profile);
	var tokenId = profile.tokenId;
	mui.ajax(
		base.getBASEURL() + 'appapi/1/user/checkLogin', {
			type: 'POST',
			data: {
				tokenId: tokenId
			},
			success: function(response) {
				if(response.success && response.errorCode == 1001) {
					var profile = eval(window.localStorage.profile);
					if(profile.vip == 1) {
						mui.toast('你已经是咨询师，无需再申请!');
						return;
					} else {
						openWindowInParent('QiNiu_Upload.html');
					}
				} else {
					mui.toast(response.msg);
					openWindowInParent('login.html');
				}
			},
			error: function(response) {
				mui.toast('网络连接失败');
			}
		}
	);
}

function _jumToQiNiuUpload() {
	checkLogin();
}

var modal = new Modal('#waiting');
var doctorList = new AdvancedList('#doctorList');
var content = document.querySelector('.mui-content');

doctorList.setItemTemplate("#doctorList>li:first-child");
doctorList.onCreateItem = function(data, item) {
	item.id = data.userId;
	item.querySelector('.mui-media-body div img').src = data.userFace + "?imageView2/1/w/65/h/65";
	item.querySelector('#name').innerHTML = data.realName;
	item.querySelector('.description').innerHTML = data.introduction;
};
var base = new BASE();
var url = base.getBASEURL() + "appapi/1/consult/recommends";

loadData();

function hideOrShowBtn() {
	var profile = eval(window.localStorage.profile);
	if(profile && profile.vip == 1) {
		document.querySelector('.becomeCounselorBtn').style.display = 'none';
	} else {
		document.querySelector('.becomeCounselorBtn').style.display = 'block';
	}

}

function loadData() {
	modal.show();
	mui.ajax(
		url, {
			data: {
				doctorsPageSize: 8
			},
			success: function(response) {
				modal.hide();
				if(base.getRUMTIME() == 1) {
					if(isAudit() == '1') {
						document.querySelector('.council_introduction').style.display='none';
					}
				}
				if(response.success) {
					doctorList.multipleAppend(response.obj);
				} else {
					mui.toast(response.msg);
				}
			},
			error: function(response) {
				modal.hide();
				mui.toast("请检查您的网络：" + JSON.stringify(response));
			}
		}
	);
}

function _jump(li) {
	openWindowInParent('doctor_detail.html?doctorId=' + li.id);
}

function search() {
	var keyword = document.getElementById('keyword').value;
	if(keyword) {
		var searchPane = document.getElementById('searchPane');
		searchPane.style.display = 'initial';
		searchPane.querySelector('#title>span').innerText = "\"" + keyword + "\"的搜索结果";
		var result = document.getElementById('result');
		searchPane.querySelector('#hide').onclick = function() {
			searchPane.style.display = 'none';
			var secondChild = result.querySelector('li:nth-child(2)');
			while(secondChild) {
				result.removeChild(secondChild);
				secondChild = result.querySelector('li:nth-child(2)');
			}
			content.style.display = 'block';
		}
		var list = new AdvancedList('#result');
		list.setItemTemplate('#result>li:first-child');
		list.onCreateItem = function(data, item) {
			item.id = data.userId;
			item.querySelector('.doctorFace').setAttribute('src', data.userFace + "?imageView2/1/w/65/h/65");
			item.querySelector('.description').innerHTML = "擅长：" + (data.attending ? data.attending : (data.introduction ? data.introduction : ''));
			var description = item.querySelector('.description').innerHTML;
			keywordChangeRed(item, '.description', description, keyword);
			item.querySelector('#name').innerText = data.realName;
			var name = item.querySelector('#name').innerHTML;
			keywordChangeRed(item, '#name', name, keyword);
			item.querySelector('#hospital').innerHTML = data.hospital ? "医院：" + data.hospital : '';
			var hospital = item.querySelector('#hospital').innerHTML;
			keywordChangeRed(item, '#hospital', hospital, keyword);
			item.querySelector('#department').innerHTML = data.department ? "部门：" + data.department : '';
			var department = item.querySelector('#department').innerHTML;
			keywordChangeRed(item, '#department', department, keyword);
			item.querySelector('#position').innerHTML = data.position ? "位置：" + data.position : '';
			var positions = item.querySelector('#position').innerHTML;
			keywordChangeRed(item, '#position', positions, keyword);
			item.style.display = 'block';
		};
		var callback = function(response) {
			var data = response.obj.list;
			content.style.display = 'none';
			if(data && data.length > 0) {
				document.getElementById('empty').style.display = 'none';
				list.multipleAppend(data);
			} else {
				document.getElementById('empty').style.display = 'block';
			}
		};
		fuzzSearch(callback, keyword);
	} else mui.toast('请在上方输入搜索内容');
}

function keywordChangeRed(item, id, html, keyword) {
	html = html.replace(new RegExp(keyword, "g"), keyword.fontcolor("#FF0000"));
	item.querySelector(id).innerHTML = html;
}

function fuzzSearch(callback, query) {
	var modal = new Modal('#waiting_searching');
	modal.show();
	var url = base.getBASEURL() + "appapi/1/consult/query?query=" + query;
	mui.ajax(
		url, {
			success: function(response) {
				modal.hide();
				callback(response);
			},
			error: function(response) {
				modal.hide();
				mui.toast("请检查您的网络：" + JSON.stringify(response));
			}
		}
	);
}

mui('.mui-scroll-wrapper').scroll({
	deceleration: 0.0005
});