var blogList = new AdvancedList("#blogList");
blogList.setItemTemplate("#blogList>li:first-child");
blogList.onCreateItem = function(data, item) {
	item.id = data.articleId;
	item.querySelector('.clickCount').innerText = data.clickCount;
	item.querySelector('.commentCount').innerText = data.commentCount ? data.commentCount : 0;
	item.querySelector('.praiseCount').innerText = data.praiseCount ? data.praiseCount : 0;
	item.querySelector('.title').innerText = data.title;
	item.querySelector('.content').innerText = new Date(data.createTime).Format('yyyy-MM-dd');
};
var profile = eval(window.localStorage.profile);
var modal = new Modal('#waiting');
var base = new BASE();
var args = GetRequest();
var doctorName;
loadData();

function scrolling() {
	var body = document.body;
	if(body.offsetHeight + 200 - window.innerHeight - body.scrollTop <= 0) pullDownRefresh();
}

function loadData() {
	if(!args.userId) return;
	modal.show();
	var url = base.getBASEURL() + "appapi/1/doctor/blog/info.do";
	var data = {
		doctorId: args.userId,
	};
	mui.ajax(url, {
		data: data,
		success: function(response) {
			var data = response.obj;
			if(!data) {
				mui.toast('加载数据失败：' + response.errorMsg);
				modal.hide();
				return;
			}
			doctorName = (data.userInfo.realName);
			document.getElementById("topName").innerText = (data.userInfo.realName);
			document.getElementById("articleNum").innerText = (data.blogInfo.articleNum);
			document.getElementById("photoNum").innerText = (data.blogInfo.albumNum);
			document.getElementById("movieNum").innerText = (data.blogInfo.videoNum);
			document.getElementById("blogNum").innerText = (data.blogInfo.articleNum);
			document.getElementById("KTNum").innerText = (data.blogInfo.classesNum);
			document.getElementById("userFace").src = (data.userInfo.userFace) + "?imageView2/1/w/92/h/92";

			if(data.userInfo.sex == 1) {
				var sexIcon = document.getElementById('sex');
				sexIcon.classList.remove('icon-nan', 'icon-sex-boy');
				sexIcon.classList.add('icon-nv', 'icon-sex-girl');
			}
			pullDownRefresh();
		},
		error: function(response) {
			if(response.status == 0) {
				loadData();
			} else {
				mui.toast("获取失败：" + JSON.stringify(response));
				modal.hide();
				document.getElementById('failed').style.display = 'initial';
			}
		}
	});
}

function shareContent() {
	share(doctorName + '的空间', '咨询师空间分享');
}

function _jump(article) {
	openWindow('doctor_blog_detail.html?articleId=' + article.id);
}

function _jumpToDetail() {
	openWindow('doctor_detail.html?doctorId=' + args.userId);
}

function _jumpToAlbum() {
	openWindow('person_album.html?userId=' + args.userId);
}

function _jumpToVideo() {
	openWindow('person_video.html?userId=' + args.userId);
}

function pullDownRefresh() {
	if(!args.userId) return;
	if(window.loading) return;
	else window.loading = true;
	var offset = blogList.container.childElementCount - 1,
		size = 6;
	var url = base.getBASEURL() + "appapi/1/blog/article/list.do?pageNo=" + offset + "&pageSize=" + size + "&doctorId=" + args.userId;
	mui.ajax(url, {
		success: function(response) {
			console.log(response);
			var data = response.data.list;
			if(data && data.length > 0) {
				blogList.multipleAppend(data);
			} else {
				//	mui.toast('没有更多数据！');
			}
			window.loading = false;
			modal.hide();
			document.getElementById('failed').style.display = 'none';
		},
		error: function(response) {
			mui.toast("网络连接失败！请重试！");
			window.loading = false;
			modal.hide();
		}
	});
}

function _jumpToIM(doctor) {
	if(!profile) {
		openWindow('login.html');
	} else {
		//	openWindow('IM.html#' + args.userId);

		var url = base.getBASEURL() + "appapi/1/consult/startConsult";
		mui.ajax(
			url, {
				type: "POST",
				data: {
					doctorId: args.userId,
					consultType: 3
				},
				success: function(response) {
					if(response.success) {
						var consultId = response.obj.consultId;
						if(base.getRUMTIME() == 1) {
							var notiClass = plus.ios.importClass("NSNotificationCenter");
							notiClass.defaultCenter().postNotificationNameobject("IM", consultId + ':' + args.userId + ':1');
						} else {
							openWindow('IM.html?consultId=' + consultId + '#' + args.userId);
						}
					} else {
						mui.toast(response.msg);
					}
				},
				error: function(response) {
					mui.toast('发送失败');
				}
			}
		);

	}
}

function _jumpToKT() {
	openWindow('KT_online.html?articleId=' + args.userId);
}

sessionStorage.removeItem('state');

/*无历史跳转到个人中心*/
var old_back = mui.back;
mui.back = function() {
	if(base.getRUMTIME() == 0) {
		if(window.history.length <= 2) {
			window.location.href = "index.html";
			return;
		}
	}
	return old_back();
}