mui.init();

function CommentsLoader(parameters) {
	PullDownLoader.call(this, parameters);
	var superUpdate = this.update;
	var list;
	var articleId;
	var commentsTotal;
	var reload = false;

	new function ScrollListener(loader) {
		var body = document.getElementsByTagName('body')[0];
		var lastBodyScrollTop = body.scrollTop;

		document.addEventListener('scroll', function onScrolling(event) {
			if(lastBodyScrollTop < body.scrollTop) {
				if(body.scrollHeight - body.scrollTop - (95 * 2) < window.innerHeight) {
					loader.loadNextPage();
				}
			}
			lastBodyScrollTop = body.scrollTop;
		});
	}(this);

	this.previousLoading = function() {
		modal.show();
	}

	this.afterLoading = function() {
		modal.hide();
	}

	this.handleSuccess = function(response) {
		document.getElementById('failed').style.display = 'none';
		document.querySelector('.mui-content').style.display = 'block';
		if(response.success) {
			if(response.obj.comments.length > 0) {
				return true;
			} else {
				if(this.getNextPage()==1)
				{
					mui.toast('没有更多数据');
				}
				this.resetCompleted(true);
				return false;
			}
		} else {
			mui.toast(response.msg);
			return false;
		}
	}

	this.handleError = function(response) {
		document.getElementById('failed').style.display = 'block';
		mui.toast("获取数据失败！");
	}

	this.doRefresh = function(response) {
		list.multipleAppend(response.obj.comments);
		document.querySelector("#comment>.count").innerText = "(" + response.obj.pager.total + ")";
		commentsTotal = response.obj.pager.total;
		if(reload)
		{
			reload=false;
			this.onReloadComplete();
		}
		return response.obj.comments.length;
	}

	this.createRequestData = function() {
		var data
		if(!reload) {
			data = {
				pageSize: this.getPageSize(),
				pageNo: this.getNextPage(),
				articleId: articleId
			};
		} else {
			data = {
				pageSize: commentsTotal + 1,
				pageNo: this.getNextPage(),
				articleId: articleId
			};
		}
		return data;
	}

	this.update = function(parameters) {
		list = parameters.list;
		articleId = parameters.articleId;
		superUpdate.call(this, parameters);
	}

	this.reload = function() {
		this.resetCompleted(false);
		this.resetLoadingState();
		this.resetHasLoaded();
		reload = true;
		list.clearAll();
		this.loadNextPage();
	}
	
	this.onReloadComplete=function()
	{
		var body=document.getElementsByTagName('body')[0];
		body.scrollTop=body.scrollHeight;
		body=null;
	}

	this.update(parameters);
}

var base = new BASE();
var args = GetRequest();
var commentList = new AdvancedList("#commentList");
commentList.setItemTemplate("#template>li:first-child");
commentList.onCreateItem = function(data, item) {
	item.id = data.commentId;
	item.querySelector('.profile').innerHTML = "<em>" + data.userName + "</em><br>" + new Date(data.createTime).Format('yyyy-MM-dd hh:mm:ss');
	item.querySelector('.text').innerText = data.content;
	if(data.replies && data.replies.length > 0) {
		var replyList = data.replies;
		var subs = document.createElement('div');
		subs.classList.add('sub');
		for(var index in replyList) {
			data = replyList[index];
			var subItem = item.cloneNode(true);
			subItem.id = data.commentId;
			subItem.querySelector('.profile').innerHTML = "<em>" + data.userName + "</em><br>" + new Date(data.createTime).Format('yyyy-MM-dd hh:mm:ss');
			subItem.querySelector('.text').innerText = data.content;
			subs.appendChild(subItem);
		}
		item.appendChild(subs);
	}
	item.style.display = 'block';
};

var modal = new Modal('#waiting');
var title = "";
var contentText = '';

var commentsLoader = new CommentsLoader({
	requestUrl: base.getBASEURL() + "appapi/1/blog/article/comment/list.do",
	pageSize: 10,
	list: commentList,
	articleId: args.articleId
});

function loadData() {
	if(!args || args.length < 1) {
		mui.toast('该博客不存在或者已删除！');
		mui.back();
		return;
	}
	modal.show();
	var url = base.getBASEURL() + "appapi/1/blog/article/detail.do?articleId=" + args.articleId;
	mui.ajax(url, {
		success: function(response) {
			modal.hide();
			title = response.obj.title;
			var data = response.obj;
			if(!data) {
				mui.toast("获取失败!");
				return;
			}

			commentsLoader.loadNextPage();

		//	document.getElementById("author").innerText = data.userName;
			document.getElementById("author").innerText = data.title;
			document.getElementById("createTime").innerText = new Date(data.createTime).Format("MM-dd hh:mm:ss");
			//	document.getElementById("content").innerHTML = data.content;
			contentText = data.summary;
			//提取文本
			var content = clearHTML(data.content);
			document.getElementById('content').innerHTML = content;
			document.getElementById("like").innerText = data.praiseCount;
			document.getElementById("click").innerText = data.clickCount;
			for(var image in data.imgs) {
				var li = document.createElement('li');
				li.setAttribute('class', 'mui-table-view-cell mui-media mui-col-xs-4 mui-col-sm-3');
				var a = document.createElement('a');
				var img = document.createElement('img');
				img.src = image.url;
				a.appendChild(img);
				li.appendChild(a);
			}
		},
		error: function(response) {
			mui.toast("获取失败：" + JSON.stringify(response));
			modal.hide();
			document.getElementById('failed').style.display = 'initial';
		}
	});
}

function like(p) {
	var profile = eval(localStorage.profile);
	if(profile) {
		var url = base.getBASEURL() + "appapi/1/blog/article/praise.do";
		mui.ajax(
			url, {
				type: "POST",
				data: {
					articleId: args.articleId
				},
				success: function(response) {
					console.info(response);
					if(response.errorCode == 1001) {
						p.innerText = parseInt(p.innerText) + 1;
						p.classList.add('liked');
					} else mui.toast('您今天已点赞过此篇文章！');
				},
				error: function(response) {
					mui.toast('请检查网络：' + JSON.stringify(response));
				}
			}
		)
	}
}

function shareContent() {
	share(title, contentText);
}

function textInput(text) {
	var send = document.getElementById('send');
	if(text.value) send.style.display = 'inline-block';
	else {
		text.style.height = 'auto';
	}
	if(text.scrollHeight < 120)
		text.style.height = text.scrollHeight + 'px';
}

function sendText() {
	var text = document.getElementById('text');
	if(text.value) {
		if(!args || args.length <= 0) {
			mui.toast('评论的博客不存在或者已删除！')
			return;
		}
		var url = base.getBASEURL() + "appapi/1/blog/article/comment.do";
		var data = {
			'articleId': args.articleId,
			'content': text.value
		};
		modal.show();
		mui.ajax(url, {
			type: 'POST',
			data: data,
			success: function(response) {
				modal.hide();
				if(response.success) {
					mui.toast('发表成功！');
					
					commentsLoader.reload();
					
					text.value = '';
				} else {
					if(response.errorMsg) mui.toast(response.errorMsg);
					if(response.msg) mui.toast(response.msg);
				}
			},
			error: function(response) {
				mui.toast('发表评论失败!请检查网络：' + JSON.stringify(response));
			}
		});
	} else mui.toast('不能发表空评论');
}

/**
 * 更新点击数
 */
var editClickCount = function() {
	mui.ajax(base.getBASEURL() + "appapi/1/blog/article/addClickCount.do", {
		type: 'POST',
		data: {
			articleId: args.articleId
		},
		success: function(response) {

		},
		error: function(response) {

		}
	});
};

(function($, doc) {
	$.init();
	$.ready(function() {
		editClickCount();
		loadData();
	});
})(mui, document);

/*无历史跳转到个人中心*/
var old_back = mui.back;
mui.back = function() {
	if(base.getRUMTIME() == 0) {
		if(window.history.length <= 2) {
			window.location.href = "index.html";
			return;
		}
	}
	return old_back();
}