var EMGCMgr = {

	base: new BASE(),

	/**
	 * 分页大小
	 */
	pageSize: 10,

	/**
	 * 当前分页
	 */
	pageNo: 0,
	/**
	 * 是否网络出错
	 */
	isNetworkError: false,

	advancedList: new AdvancedList("#helpDesk"),

	/**
	 * 初始化数据
	 */
	initData: function() {
		EMGCMgr.advancedList.setItemTemplate("#helpDesk>li:first-child");
		EMGCMgr.advancedList.onCreateItem = function(data, item) {
			item.id = data.id;
			item.querySelector('.create-time').innerText = new Date(data.createTime).Format('yyyy-MM-dd');
			item.querySelector('.EmCen_name>img').src = data.userFace + "?imageView2/1/w/65/h/65";
			//显示用户名
			item.querySelector('.nickname').innerText = data.realName;
			item.querySelector('.EmCen_pricecolor').innerText = data.reward;
			item.querySelector('.EmCen_title').innerText = data.title;
			item.querySelector('.succourStatus').innerText = data.succourStatus == 0 ? '未解决' : '已解决';
			item.querySelector('.succourStatus').style.color = data.succourStatus == 0 ? '#007AFF' : '#8B0000';
			//	item.querySelector('.description').innerText=data.description;
		};

	},

	/**
	 *获取数据列表 
	 */
	getDataList: function() {

		EMGCMgr.pageNo++;

		var url = EMGCMgr.base.getBASEURL() + "appapi/1/succour/list";
		mui.ajax(url, {
			data: {
				pageNo: EMGCMgr.pageNo,
				pageSize: EMGCMgr.pageSize
			},
			success: function(response) {
				var base = new BASE();
				if(base.getRUMTIME() == 1) {
					if(isAudit() == '1') {
						document.querySelector('.EmCen_price').style.display = 'none';
						document.querySelector('.EmCen_pricecolor').style.display = 'none';
						document.querySelector('.moreBtn').style.display = 'none';
						document.querySelector('.EmCen_introduction').style.display='none';
					}
				}
				if(response.success) {
					var data = response.obj.list;
					if(data && data.length > 0) {
						EMGCMgr.advancedList.multipleAppend(data);
						mui('#pullrefresh').pullRefresh().endPullupToRefresh(false); //有数据结束加载
					} else {
						mui('#pullrefresh').pullRefresh().endPullupToRefresh(true); //无数据结束加载
					}
				} else {
					mui.toast(response.msg);
				}
			},
			error: function(response) {
				mui.toast("网络连接失败！请重试！");
			}
		});
	},

	/**
	 * 重新刷新数据
	 */
	resetData: function() {
		mui('#pullrefresh').pullRefresh().refresh(true); //重置上拉加载
		EMGCMgr.advancedList.clearAll();
		EMGCMgr.pageNo = 0;
		EMGCMgr.getDataList();
	},

	/**
	 * 下拉刷新
	 */
	pulldownRefresh: function() {
		if(EMGCMgr.isNetworkError) {
			setTimeout(function() {
				EMGCMgr.resetData();
				EMGCMgr.isNetworkError = false;
			}, 800);
		} else {
			mui('#pullrefresh').pullRefresh().endPulldownToRefresh(); //refresh completed
		}
	},

	/**
	 * 上拉加载下一页
	 */
	pullupRefresh: function() {
		setTimeout(function() {
			EMGCMgr.getDataList();
		}, 800);
	},

	callUp: function() {

	}

};

(function($, doc) {
	//初始化MUI及下拉控件
	$.init({
		pullRefresh: {
			container: '#pullrefresh',
			down: {
				callback: EMGCMgr.pulldownRefresh
			},
			up: {
				contentrefresh: '正在加载...',
				contentnomore: '没有更多数据了', //可选，请求完毕若没有更多数据时显示的提醒内容；
				callback: EMGCMgr.pullupRefresh
			}
		}

	});
	/**
	 * 初始化数据
	 */
	EMGCMgr.initData();
	//点击更多
	doc.getElementById("btnMore").addEventListener('tap', function() {
		openWindowInParent('EmergencyCenter_SalvageListPage.html')
		return false;
	});
	//点击列表项
	mui('#helpDesk').on('tap', '.mui-table-view-cell', function() {
		openWindowInParent('EmergencyCenter_Answer.html?succourId=' + this.id);
	});
	//呼叫
	doc.getElementById("btnCall").addEventListener('tap', function() {
		if(new BASE().getRUMTIME() == '1') {
			if(plus && plus.ios) {
				var NSNotificationCenter = plus.ios.importClass("NSNotificationCenter");
				NSNotificationCenter.defaultCenter().postNotificationNameobject("callUp", this.innerText);
				//			NSNotificationCenter.defaultCenter().postNotificationNameobject("EMGCMgr.callUp", this.innerText);
			}
		}

	});
	//立即发布
	doc.getElementById("btnRelease").addEventListener('tap', function() {
		if(!window.localStorage.profile) {
			openWindowInParent('login.html');
		} else {
			if(new BASE().getRUMTIME() == 1) {
				if(isAudit() == '1') {
					openWindowInParent('looking_for_help2.html');
				} else {
					openWindowInParent('looking_for_help.html');
				}
			} else {
				openWindowInParent('looking_for_help.html');
			}
		}
	});
	//
	//	if($.os.plus) {
	//		$.plusReady(function() {
	//			setTimeout(function() {
	//				$('#pullrefresh').pullRefresh().pullupLoading();
	//			}, 500);
	//		});
	//	} else {
	$.ready(function() {
		$('#pullrefresh').pullRefresh().pullupLoading();
	});
	//	}

})(mui, document);