var args = new GetRequest();
var base = new BASE();
var deadline = undefined;
var myAnswers = new AdvancedList("#answers_list");
var reward = 0;
var isAdoption = 0;
var leftReward = 0;
var timer = setInterval('countDown()', 1000);
//var modal=MUIPopover.waitingDefault({backgroundAlpha:0.3});
var modal = MUIPopover.waiting({text:'加载中...', backgroundAlpha:0.5});

var count = 0;
var replenish;
var userId;
var map;
var lat;
var lng;

// 用经纬度设置地图中心点
function theLocation(lat, lng) {
	map.clearOverlays();
	var new_point = new BMap.Point(lng, lat);
	var marker = new BMap.Marker(new_point); // 创建标注
	map.addOverlay(marker); // 将标注添加到地图中
	map.panTo(new_point);
}

/**
 * 初始化地图
 * 
 * @param {Object} lng
 * @param {Object} lat
 */
function initMap(lng, lat) {
	// 百度地图API功能
	map = new BMap.Map("allmap");
	var point = new BMap.Point(lng, lat);
	map.centerAndZoom(point, 10);
	var top_left_control = new BMap.ScaleControl({
		anchor: BMAP_ANCHOR_TOP_LEFT
	}); // 左上角，添加比例尺
	var top_left_navigation = new BMap.NavigationControl(); //左上角，添加默认缩放平移控件
	var top_right_navigation = new BMap.NavigationControl({
		anchor: BMAP_ANCHOR_TOP_RIGHT,
		type: BMAP_NAVIGATION_CONTROL_SMALL
	}); //右上角，仅包含平移和缩放按钮
	//添加控件和比例尺
	map.addControl(top_left_control);
	map.addControl(top_right_navigation);
	setTimeout(function() {
		var marker = new BMap.Marker(point); // 创建标注
		map.addOverlay(marker);
		map.panTo(point);
	}, 500);
}

myAnswers.clearAll = function() {
	var dom_answers_list = document.getElementById('answers_list');
	var items = dom_answers_list.querySelectorAll('.answer-list-item');
	for(var i = 1; i < items.length; ++i) {
		dom_answers_list.removeChild(items[i]);
	}
}

myAnswers.setItemTemplate("#answers_list>div:first-child");

myAnswers.onCreateItem = function(data, item) {
	item.style.display = 'block';
	item.querySelector(".answer_title").innerText = data.realName + " 于" + new Date(data.talkTime).Format("yyyy-MM-dd hh:mm:ss") + "回答";
	item.querySelector(".answer_content").innerText = data.content;
	item.userId = data.userId;
	item.talkId = data.id;
	item.id = data.id;

	var profile = eval(localStorage.profile);

	var btn = item.querySelector('.btn_confirm');
	if(btn) {
		if(data.isAdoption == 1) {
			isAdoption = data.isAdoption;
			btn.innerText = '已采纳';
			btn.classList.add('btn_adoption');
			btn.setAttribute('disabled', true);
		}
	}

	//回复者本人 已采纳
	if(profile && profile.userId && profile.userId == data.userId) {
		if(data.isAdoption) {
			//显示提示
			//	item.querySelector('.answer-accecpted').classList.add('show');

			//标记颜色
			item.querySelector('.answer_content').classList.add('accepted');
		}
	}
}

function loadData() {
	if(!args.succourId) {
		mui.toast('该求助不存在或者已删除！');
		mui.back();
		return;
	}
	var url = base.getBASEURL() + "appapi/1/succour/detail";
	var appendArray = [];

	//	var waiting=document.getElementById('waiting').cloneNode(true);
	//	waiting.style.display='block';
	//	modal.doModal(waiting);

	mui.ajax(url, {
		data: {
			succourId: args.succourId
		},
		success: function(response) {
			modal.close();
			if(base.getRUMTIME() == 1) {
				//				document.getElementById('allmap').style.display = 'none';
				if(isAudit() == '0') {
					showFee();
				}
			} else {
				//				document.querySelector('.checkMapText').style.display = 'none';
				showFee();
			}
			if(response.success) {
				var data = response.obj;
				replenish = data.replenish;
				window.deadline = data.deadline;
				document.getElementById("realName").innerText = data.realName;
				document.getElementById('createTime').innerText = new Date(data.createTime).Format('yyyy-MM-dd');
				document.getElementById('avatar').src = data.userFace + "?imageView2/1/w/65/h/65";
				document.getElementById('deadline').innerText = new Date(data.deadline).Format('yyyy-MM-dd');
				document.getElementById('price').innerText = data.reward;
				document.getElementById('left').innerText = data.leftReward;
				document.getElementById('total').innerText = data.solves;
				document.getElementById('accept').innerText = data.adoptions;
				document.getElementById('content').innerText = data.description;
				leftReward = data.leftReward;
				if(base.getRUMTIME() == 1) {
					lat = data.lat;
					lng = data.lng;
				}
				//定位地图
				initMap(data.lng, data.lat);

				if(data.address) {
					document.querySelector('.EmCen_location').style.display = 'block';
					document.getElementById('locationText').innerText = data.address;
				} else {
					document.querySelector('.EmCen_location').style.display = 'none';
				}
				if(data.picArray.length > 0) {
					for(var i = 0; i < data.picArray.length; i++) {
						appendArray.push(data.picArray[i]);
					}
				}
				if(data.videoArray.length > 0) {
					for(var i = 0; i < data.videoArray.length; i++) {
						appendArray.push(data.videoArray[i]);
					}
				}
				if(data.voiceArray.length > 0) {
					for(var i = 0; i < data.voiceArray.length; i++) {
						appendArray.push(data.voiceArray[i]);
					}
				}

				if(appendArray.length > 0) {
					document.querySelector('.attachment').style.display = 'block';
					if(count == 0) {
						append(appendArray);
					}
					count++;
				} else {
					document.querySelector('.attachment').style.display = 'none';
				}

				reward = parseFloat(data.reward);
				isAdoption = data.adoptions; //以解决/未解决

				if(isNaN(reward)) {
					mui.toast('没有金额返回值');
					return;
				}

				if((new Date(data.deadline).getTime() - new Date().getTime()) <= 0) {
					document.getElementById('answers_content').style.display = 'none';
				}

				response.obj.talks.sort(function(a, b) {
					return b.talkTime - a.talkTime;
				});

				userId = response.obj.userId;
				var profile = eval(window.localStorage.profile);

				checkisAdoption(userId);
				changeLayout();
				myAnswers.multipleAppend(response.obj.talks);

				if(profile && profile.userId && (profile.userId == userId)) {
					document.getElementById('answers_content').style.display = 'none';
				}
			} else mui.toast(response.msg);
		},
		error: function(response) {
			mui.toast("获取失败：" + JSON.stringify(response));
			modal.close();
		}
	});
}

function showFee() {
	document.querySelector('.EmCen_price').style.display = 'inline-block';
	document.querySelector('.remain').style.display = 'inline-block';
	document.querySelector('.EmCen_ans_tipsbox').style.display = 'block';
	document.getElementById('left').style.display = 'inline-block';
	document.getElementById('price').style.display = 'inline-block';
}

function checkisAdoption(userId) {
	var profile = eval(localStorage.profile);
	//非发布者屏蔽按钮
	if(profile && profile.userId && (profile.userId != userId)) {
		var template = document.querySelector('#answers_list>div:first-child');
		var acBtn = template.querySelector('.btn_confirm');
		var adviceBtn = template.querySelector('.btn_advice');

		if(acBtn) {
			acBtn.parentNode.removeChild(acBtn);
		}

		if(adviceBtn) {
			adviceBtn.parentNode.removeChild(adviceBtn);
		}
	}
}

function append(dataArray) {
	console.log(dataArray.length);
	var attachmentList = document.getElementById('attachmemtList');
	var imageReg = new RegExp("(.jpg|.png|.bmp|.jpeg)$");
	var videoReg = new RegExp("(.mp4|.flv|.mov)$");
	var voiceReg = new RegExp("(.mp3|.wav|.amr)$");
	for(var i = 0; i < dataArray.length; i++) {
		var li = document.createElement('li');
		if(imageReg.test(dataArray[i].url)) {
			var img = document.createElement('img');
			img.src = dataArray[i].url;
			img.style.height = '100%';
			img.style.width = 'auto';
			li.appendChild(img);
		} else if(videoReg.test(dataArray[i].url)) {
			var video = document.createElement('video');
			li.classList.add('movie');
			video.src = dataArray[i].url;
			video.style.height = '100%';
			li.appendChild(video);
		} else if(voiceReg.test(dataArray[i].url)) {
			var audio = document.createElement('audio');
			li.classList.add('music');
			audio.src = dataArray[i].url;
			audio.style.height = '100%';
			li.appendChild(audio);
		}
		li.onclick = onMediaItmClick;
		attachmentList.insertBefore(li, attachmentList.lastElementChild);
	}
}

function onMediaItmClick(event) {
	showAttachment(event.target || event.srcElement);
}

function showAttachment(li) {
	var child = li.firstElementChild;
	MUIPopover.autoPopover({
		domSource: li,
		backgroundAlpha:0.9,
		closeHandler:function(dlg)
		{
			dlg.close();
		}
	});
}

function submitAddContent() {
	if(checkBtnStatus()==0){
		return;
	}
	var url = base.getBASEURL() + "/appapi/1/succour/replenish";
	var addContent = document.getElementById('addContent');
	console.log(args.succourId);
	console.log(addContent.value);
	var data = {
		succourId: args.succourId,
		replenish: addContent.value
	};
	console.log(data);
	mui.ajax(
		url, {
			type: 'POST',
			data: data,
			success: function(response) {
				console.log(response);
				if(response.success) {
					mui.toast('提交成功');
					document.querySelector('.addBtn').style.backgroundColor = '#808080';
					document.querySelector('.addBtn').innerHTML = '修改';
					document.getElementById('addContent').setAttribute('readonly',true);
				} else mui.toast('提交失败：' + response.msg);
			},
			error: function(response) {
				mui.toast('提交失败：' + JSON.stringify(response));
			}
		}
	);
}

function checkBtnStatus(){
	if(document.querySelector('.addBtn').innerHTML == '修改') {
		document.querySelector('.addBtn').style.backgroundColor = '#288629';
		document.querySelector('.addBtn').innerHTML = '保存';
		document.getElementById('addContent').removeAttribute('readonly');
		mui.toast('可以修改了喔');
		return 0;
	}
	return 1;
}

function reply() {
	var content = document.getElementById('reply');
	if(content && content.value) {
		var url = base.getBASEURL() + "appapi/1/succour/answer";
		var data = {
			succourId: args.succourId,
			content: content.value
		};
		mui.ajax(
			url, {
				type: 'POST',
				data: data,
				success: function(response) {
					if(response.success) {
						content.value = '';
						mui.toast('回复成功');
						myAnswers.clearAll();
						loadData();
					} else {
						mui.toast('回复失败：' + response.msg);
						if(response.msg == '未登录') {
							openWindow('login.html');
						}
					};
				},
				error: function(response) {
					mui.toast('回复失败：' + JSON.stringify(response));
				}
			}
		);
	} else mui.toast('回复内容不能为空！');
}

function openMap() {
	var notiClass = plus.ios.importClass("NSNotificationCenter");
	notiClass.defaultCenter().postNotificationNameobject("rarpLocation", lat + ':' + lng);
}

function countDown() {
	deadline = new Date(window.deadline).getTime();

	var left;
	if(!deadline) return;
	else left = deadline - new Date().getTime();

	if(left <= 0) {
		clearInterval(timer);
		timer = null;
		//	remain=(0)+"天"+(0)+"小时"+(0)+"分"+(0)+"秒";
		remain = "已过期";
		document.getElementById('remain').innerText = remain;
		if(replenish) {
			document.getElementById('addContent_list').style.display = 'block';
			document.getElementById('addContent').innerHTML = replenish;
			document.querySelector('.addBtn').style.display = 'none';
			document.getElementById('addContent').setAttribute('readonly',true);
		} else {
			document.getElementById('addContent_list').style.display = 'none';
		}
		return;
	}
	var second = left / 1000;
	var minute = second / 60;
	var hour = minute / 60;
	var day = hour / 24;
	var remain = (0 | day) + "天" + (0 | hour % 24) + "小时" + (0 | minute % 60) + "分" + (0 | second % 60) + "秒";
	document.getElementById('remain').innerText = remain;
}

function changeLayout() {
	var profile = eval(window.localStorage.profile);
//	profile.userId;
//	userId;
//	replenish;
	if(profile.userId == userId && !replenish) {
		document.getElementById('addContent_list').style.display = 'block';
		document.querySelector('.addBtn').style.display = 'block';
	} else if(profile.userId == userId && replenish) {
		document.getElementById('addContent_list').style.display = 'block';
		document.getElementById('addContent').setAttribute('readonly',true);
		document.getElementById('addContent').innerHTML = replenish;
		document.querySelector('.addBtn').style.backgroundColor = '#808080';
		document.querySelector('.addBtn').innerHTML = '修改';
	}else if(profile.userId != userId && replenish){
		document.querySelector('.addBtn').style.display = 'none';
		document.getElementById('addContent').setAttribute('readonly',true);
		document.getElementById('addContent').innerHTML = replenish;
		document.querySelector('.addBtn').style.backgroundColor = '#808080';
	}
}

function acceptAnswer(div) {
	var text = div.querySelector('.answer_content').innerText;

	mui.confirm(text, "是否采纳解答：", ['是', '否'], function(event) {
		if(event.index == 0) {
			var rewardInput;
			if(base.getRUMTIME() == 1) {
				if(isAudit() == '1') {
					acceptWithReward(0, div);
					return;
				}
			}
			if(leftReward == 0) {
				rewardInput = 0;
				acceptWithReward(rewardInput, div);
			} else {
				mui.prompt('输入采纳金额：', 0, '剩余：' + reward, function(e) {
					if(e.index == 1) {
						rewardInput = parseFloat(e.value);
						if(isNaN(rewardInput)) {
							console.error(e);
							mui.toast('请输入正确的金额');
							return;
						}

						if(rewardInput > reward) {
							mui.toast('悬赏金额超出范围');
							return;
						}
						acceptWithReward(rewardInput, div);
					}
				});
			}
		}
	});
}

function acceptWithReward(rewardInput, div) {
	var talkId = div.talkId;
	var succourId = args.succourId;
	var url = base.getBASEURL() + "appapi/1/succour/confirmAdoption";
	mui.ajax(
		url, {
			type: 'POST',
			data: {
				succourId: succourId,
				talkId: talkId,
				reward: rewardInput
			},
			success: function(response) {
				if(response.success) {
					mui.toast('已采纳');
					myAnswers.clearAll();
					loadData();
				} else {
					mui.toast(response.msg);
				}
			},
			error: function(response) {
				mui.toast('网络连接失败，请重试');
			}
		}
	);
}

function advice(div) {
	var url = base.getBASEURL() + "appapi/1/consult/startConsult";
	var userId = div.userId;

	mui.ajax(
		url, {
			type: "POST",
			data: {
				doctorId: userId,
				consultType: 2
			},
			success: function(response) {
				if(response.success) {
					if(response.errorCode == 1001) {
						var consultId = response.obj.consultId;
						if(base.getRUMTIME() == 1) {
							var notiClass = plus.ios.importClass("NSNotificationCenter");
							notiClass.defaultCenter().postNotificationNameobject("IM", consultId + ':' + div.userId + ':1');
						} else {
							openWindow('IM.html?consultId=' + consultId + '#' + userId);
						}
					} else {
						mui.toast(response.msg);
					}
				} else {
					mui.toast(response.msg);
				}
			},
			error: function(response) {
				mui.toast('发送失败');
			}
		}
	);
}

// 我要投诉
if(document.getElementById("promptBtn")) {
	document.getElementById("promptBtn").addEventListener('tap', function(e) {
		e.detail.gesture.preventDefault();
		var btnArray = ['确定', '取消'];
		mui.prompt(' ', '请填写投诉建议', '投诉建议', btnArray, function(e) {
			if(e.index == 0) { // 确定按钮
				mui.toast('投诉已成功提交，我们将尽快处理');
			} else { //取消按钮

			}
		})
	});
}

(function($, doc) {
	$.init();

	$.ready(function() {

		myAnswers.clearAll();

		loadData();

	});

})(mui, document);

/*无历史跳转到个人中心*/
var old_back = mui.back;
mui.back = function() {
	if(base.getRUMTIME() == 0) {
		if(window.history.length <= 2) {
			window.location.href = "index.html";
			return;
		}
	}
	return old_back();
}