/*
 * 初始化模块
 */
function initialize(){
	//初始化SDK
	var resp = RL_YTX.init('8a216da85697f54201569c6a8e7102eb'); 
	if(170002== resp.code){
		//缺少必要参数，详情见msg参数
		console.error("缺少必要参数:"+JSON.stringify(resp));
		//用户逻辑处理
	}else if(174001 == resp.code){
		//不支持HTML5，关闭页面
		console.error("不支持HTML5:"+JSON.stringify(resp));
		//用户逻辑处理
	}else if(200 == resp.code){
	//初始化成功
	//用户逻辑处理
    //判断不支持的功能，屏蔽页面展示
    console.log("初始化成功:"+JSON.stringify(resp));
   }
}
/*
 * 生成签名
 */
function getSig(name){
    var appToken = 'b088ce9a6c52b36f0afbe162614e80ec';//使用是赋值为应用对应的appToken
    var appId='8a216da85697f54201569c6a8e7102eb';
    var timestamp=getTimeStamp();
    return hex_md5(appId + name + timestamp + appToken);
}

var isWarnLogin = false;

/**
 * IM即时聊天的封装
 * @param {Object} account IM账号
 */
function IM(account){
	this.account=account;
	/**
	 * 登录方法
	 */
	this.onLoginSucceed=function(obj){
		//登录成功方法回调
    	console.info("登录成功："+JSON.stringify(obj));
	};
	this.onLoginFailed=function(obj){
    	//登录失败方法回调
    	console.info("登录失败："+JSON.stringify(obj));
    	mui.toast("获取失败，请重新进入。");
    	mui.back();
	};
	this.onLogin=function(obj){
		//登录成功方法回调
		this.onLoginSucceed(obj);
		//收到push消息或者离线消息
		RL_YTX.onMsgReceiveListener(this.onMessageReceived.bind(this));
    	//注册群组通知事件监听
    	RL_YTX.onNoticeReceiveListener(this.onNoticeReceive.bind(this));
       	//连接状态变更
		RL_YTX.onConnectStateChangeLisenter(this.onConnectStateChanged.bind(this));
		//接收VoIP消息通知
		RL_YTX.onCallMsgListener(function(callback){
			mui.toast("收到"+callback.caller+"语音视频的呼叫，请使用APP接听");
			//网页一律拒接VoIP的通话请求
			var reject = new RL_YTX.RejectCallBuilder();
			reject.setCallId(callback.callId);//请求的callId
			reject.setCaller(callback.caller);//请求的主叫号码
			//reject.setReason("用户所用Web版本不支持视频语音通话");//拒接的原因
			RL_YTX.rejectCall(reject,function(){mui.toast("已拒接对方来电！")},
			function(obj){
					console.info("拒接失败："+JSON.stringify(obj));
				}
			);
		});
	};
	this.login=function(password){
		//账号登录参数设置
		var loginBuilder = new RL_YTX.LoginBuilder();
		loginBuilder.setType(1);//登录类型 1账号登录，3voip账号密码登录
		loginBuilder.setUserName(this.account);//设置用户名
		loginBuilder.setPwd(password);//type值为1时，密码可以不赋值
		loginBuilder.setSig(getSig(this.account));//设置sig
		loginBuilder.setTimestamp(getTimeStamp());//设置时间戳
		RL_YTX.login(loginBuilder,this.onLogin.bind(this),this.onLoginFailed.bind(this));
	};
	this.onLogoutSucceed=function(){
		console.log('注销成功');
	};
	this.onLogoutFailed=function(obj){
		console.log('注销失败：'+JSON.stringify(obj));
	};
	this.logout=function(){
		RL_YTX.logout(this.onLogoutSucceed.bind(this),this.onLogoutFailed.bind(this));
	};
	this.createGroup=function(groupName,description,success,failure){
		//新建创建群组对象
		var obj = new RL_YTX.CreateGroupBuilder();
		//设置群组名称
		obj.setGroupName(groupName);
		//设置群组公告
		obj. setDeclared(description);
		// 设置群组类型，如：1临时群组（100人）
		obj. setScope(1);
		// 设置群组验证权限，如：需要身份验证2
		obj. setPermission(1);
		//设置为讨论组 该字段默认为2 表示群组，创建讨论组时设置为1
		obj.setTarget(2);
		//发送消息
		RL_YTX.createGroup(obj, success, failure);
	}
	this.searchGroupById=function(groupId,success,failure){
		var builder = new RL_YTX.SearchGroupsBuilder(1,groupId);
		//搜索类型 1群组id精确查找 2 群组名称模糊搜索
		RL_YTX.searchGroups(builder, success, failure);
	};
	this.getJointGroupList=function(success,failure){
		//新建获取群组列表请求对象
		var obj = new RL_YTX.GetGroupListBuilder();
		//设置获取群组数量，该接口为分页接口，如果要获取全部数据，设置pageSize为-1
		obj.setPageSize(-1);
		obj.setTarget(2); //获取群组列表。默认为群组列表，如果要获取讨论组列表，该值传1。
		RL_YTX.getGroupList(obj,success,failure);
	};
	this.joinGroup=function(groupId,success,failure){
		var builder = new RL_YTX.JoinGroupBuilder();
		//设置申请群组id
		builder.setGroupId(groupId);
		//发送请求
		RL_YTX.joinGroup(builder,success,failure);
	};
	this.sendText=function(text,to){
		//新建消息体对象
		var msg = new RL_YTX.MsgBuilder();
		//设置发送的文本内容
		msg.setText(text);
		//设置发送的消息类型1文本消息4 图片消息6 附件消息
		//发送非文本消息时，text字段将被忽略，发送文本消息时 file字段将被忽略
		msg.setType(1);
		this.sendMessage(msg,to);
	};
	this.sendVoice=function(voice,to){
		//新建消息体对象
		var msg = new RL_YTX.MsgBuilder();
		//设置发送的图片
		msg.setFile(voice);
		//设置发送的消息类型1文本消息4 图片消息6 附件消息
		//发送非文本消息时，text字段将被忽略，发送文本消息时 file字段将被忽略
		msg.setType(2);
		this.sendMessage(msg,to);
	}
	this.sendImage=function(picture,to,progressCallback){
		//新建消息体对象
		var msg = new RL_YTX.MsgBuilder();
		//设置发送的图片
		msg.setFile(picture);
		//设置发送的消息类型1文本消息4 图片消息6 附件消息
		//发送非文本消息时，text字段将被忽略，发送文本消息时 file字段将被忽略
		msg.setType(4);
		this.sendMessage(msg,to,progressCallback);
	};
	this.sendFile=function(file,to){
		//新建消息体对象
		var msg = new RL_YTX.MsgBuilder();
		//设置发送的文件
		msg.setFile(file);
		//设置发送的消息类型1文本消息4 图片消息6 附件消息
		//发送非文本消息时，text字段将被忽略，发送文本消息时 file字段将被忽略
		msg.setType(6);
		this.sendMessage(msg,to);
	};
	this.sendMessage=function(msg,to,progressCallback){
		//设置自定义消息id
		msg.setId(hex_md5(getTimeStamp()));
		msg.setReceiver(to);
		RL_YTX.sendMsg(msg, function(){
			//发送消息成功
			console.info("发送成功");
			//处理用户逻辑，通知页面
		}, function(obj){//失败
			//发送消息失败
			console.info("发送失败："+JSON.stringify(obj));
			//处理用户逻辑，通知页面刷新，展现重发按钮
			
			if(progressCallback)
			{
				progressCallback(false,null,null);
			}
		}, function(sent, total){
			console.info("发送进度："+sent/total);
			//发送图片或附件时的进度条
			//如果发送文本消息，可以不传该参数
			
			if(progressCallback)
			{
				progressCallback(true,sent/total,msg,send,total);
			}
		});
	};
	this.onMessageReceived=function(obj){
		//收到push消息或者离线消息
    	console.info("收到推送："+JSON.stringify(obj));
	};
	this.onNoticeReceive=function(obj){
		//收到群组通知
    	console.info("收到群组消息："+JSON.stringify(obj));
	};
	this.onConnectStateChanged=function(obj){
       	//连接状态变更
    	console.info("状态变更："+JSON.stringify(obj));
    	if(!isWarnLogin){
    		retryLogin(obj.msg);
    		isWarnLogin = true;
    	}

	}
	
/*
 * 设置账号昵称
 * ethan 20161129
 */
	this.updateNickname = function(nickname){
	var personInfo = new RL_YTX.UploadPersonInfoBuilder(nickname);
//  personInfo.setNickName = nickname;
    RL_YTX.uploadPerfonInfo(personInfo,
    	function(){console.info("修改用户呢称成功:"+nickname)},
		function(obj){
						console.info("修改用户呢称失败："+JSON.stringify(obj));
				     }
    	);
	}
	
	/**
	 *  obj.state;//在线状态 1:在线 2:离线 当用户为离线状态时，obj.state,obj.network和obj.device为undefined
		obj.network;//被查询人员的网络状态 1:WIFI 2:4G 3:3G 4:2G 5:INTERNET 6:other
		obj.device;//终端类型 1:Android 2:iPhone 10:iPad 11:Android Pad 20:PC 21:H5
	 */
	this.getUserState = function(userid,callback){
		var builder = new RL_YTX.GetUserStateBuilder(userid);
    	RL_YTX.getUserState(builder,
    		function(obj){
    			console.info("获取用户状态成功:"+JSON.stringify(obj));
    			callback(obj);
//  			mui.toast("聊天对象获取成功");
    		},
			function(obj){
				console.info("修改用户状态失败："+JSON.stringify(obj));
//				mui.toast("聊天对象获取无法获取");
		    }
    	);
	}
}
/*
 * 设置账号昵称
 * ethan 20161129
 */
//function updateNickname(nickname){
//	var personInfo = new RL_YTX.UploadPersonInfoBuilder();
//  personInfo.nickName = nickname;
//  RL_YTX.uploadPersonInfo(personInfo,function callback(obj){
//					console.info(obj); //个人信息版本号
//			},function onError(obj){
//					console.info(obj); //个人信息版本号
//			} 
//
//  	);
//}

function retryLogin(msg){
		mui.confirm('是否重连？', msg, ['是', '否'], function(event) {
			if(event.index == 0) {
				im.login();
			 }else{
			 	mui.back();
			 }
			 isWarnLogin = false;
		});
}

function getTimeStamp() {
    var now = new Date();
    var timestamp = now.getFullYear() + ''
            + ((now.getMonth() + 1) >= 10 ?""+ (now.getMonth() + 1) : "0"
            + (now.getMonth() + 1))
            + (now.getDate() >= 10 ? now.getDate() : "0"
            + now.getDate())
            + (now.getHours() >= 10 ? now.getHours() : "0"
        	+ now.getHours())
            + (now.getMinutes() >= 10 ? now.getMinutes() : "0"
            + now.getMinutes())
            + (now.getSeconds() >= 10 ? now.getSeconds() : "0"
            + now.getSeconds());
    return timestamp;
}
/**
 * 将聊天列表的父级div滚动到底部
 */
function scrollToBottom(){
	var container=document.getElementById('container');
	container.scrollTop=container.scrollHeight;
}
/**
 * 将聊天列表的父级div滚动到顶部
 */
function scrollToTop(){
	window.disablePullRefresh=true;
	var container=document.getElementById('container');
	container.scrollTop=0;
	window.disablePullRefresh=false;
}
/**
 * 消息列表的封装
 * @param {Object} selector 代表消息列表的选择器字符串
 */
function MessageList(selector){
	this.container=document.querySelector(selector);//消息列表容器
	this.offset=0;//已显示的消息条数
	/**
	 * 必须先设置发送消息的模板才能正确显示发送的消息
	 */
	this.setSendTemplate=function(selector){
		if(selector instanceof HTMLElement)this.sendTemplate=selector;
		else this.sendTemplate=document.querySelector(selector);
	};
	/**
	 * 必须先设置接收消息的模板才能正确显示接收的消息
	 */
	this.setReceivedTemplate=function(selector){
		if(selector instanceof HTMLElement)this.receivedTemplate=selector;
		else this.receivedTemplate=document.querySelector(selector);
	};
	/**
	 * 创建文本消息
	 */
	this.createText=function(text){
		var item=document.createElement('p');
		item.innerHTML=text;
		return item;
	};
	/**
	 * 创建语音消息
	 */
	this.createVoice=function(voice){
    	var a=document.createElement('a');
    	a.setAttribute('class','voice');
    	if(voice.duration && voice.duration!='0'){
    		duration=voice.duration;
    	}else{
    		duration = Math.ceil(voice.msgFileSize/500);
    	}
    	a.innerHTML=duration+"'";
    	a.onclick=function(){playVoice(voice.msgFileUrl);}.bind(voice);
    	return a;
	};
	/**
	 * 创建短视频消息
	 */
	this.createVideo=function(video){
    	var _video=document.createElement('video');
    	_video.style.width='100%';
    	_video.src=video.msgFileUrl;
    	_video.innerHTML=video.msgFileName;
    	if(video.hasOwnProperty('msgFileUrlThum'))
    	{
    		_video.setAttribute('poster',video.msgFileUrlThum);
    	}
    	_video.onclick=function(){
			playVideo(this.src,this.innerHTML);
		}.bind(_video);
    	return _video;
	};
	/**
	 * 创建图片消息
	 */
	this.createImage=function(image){
		var _image=document.createElement('img');
		_image.onclick=function(){
			showImage(this.src,this.alt);
		}.bind(_image);
		_image.src=image.msgFileUrl;
		_image.alt=image.msgFileName;
		return _image;
	};
	/**
	 * 创建附件消息
	 */
	this.createFile=function(file){
    	var a=document.createElement('a');
    	a.target='_blank';
    	a.href=file.msgFileUrl;
    	a.innerHTML=file.msgFileName;
    	a.download=file.msgFileName;
    	return a;
	};
	/**
	 * 根据消息的类型自动创建对应的html
	 */
	this.createMessage=function(msg){
		var msgItem;
		switch(msg.msgType){
			case 1:
				msgItem = this.createText(msg.msgContent);
				break;
			case 2:
				msgItem = this.createVoice(msg);
				break;
			case 3:
				msgItem = this.createVideo(msg);
				break;
			case 4:
				msgItem = this.createImage(msg);
				break;
			case 6:
			case 7:
				msgItem = this.createFile(msg);
				break;
			default : return null;
		}
		if(window.user == msg.msgSender){
			msgItem = this.sendMessage(msgItem);
		}
		else{
			msgItem = this.receivedMessage(msgItem);
			if(msg.msgReceiver==window.objective){
				if(loadProfile)loadProfile(msg.msgSender,function(data){
					var img=msgItem.querySelector('a>img');
					img.src=data.userFace;
					var p=document.createElement('p');
					p.innerText=(data.realName && data.realName != "null") ? data.realName : data.userName;
					img.parentNode.insertBefore(p,img.nextSibling);
				});
				else console.error('未定义loadProfile，无法获取用户资料');
			}
		}
		if(this.container.querySelector("#_"+msg.msgDateCreated)){
			console.info("编号为"+msg.msgDateCreated+"的消息已存在！");
			return null;
		}
		msgItem.id="_"+msg.msgDateCreated;
		msgItem.dataset.time=new Date(msg.msgDateCreated-0).Format("yyyy-MM-dd hh:mm:ss");
		/*
		var pseudoInfo=this.getCreatingTimeText(msgItem,msg);
		if(pseudoInfo!=null)
		{
			msgItem.dataset.time=pseudoInfo;
		}*/
		
		return msgItem;
	}
	this.getItemById=function(id){
		return document.getElementById(id)
	}
	this.removeItemById=function(id){
		var item=document.getElementById(id);
		this.container.removeChild(item);
	};
	this.prependItem=function(item){
		if(!item)return;
		if(this.container.hasChildNodes())
			this.container.insertBefore(item,this.container.firstChild);
		else this.container.appendChild(item);
		scrollToTop();
		this.offset=this.container.childElementCount;
	}
	/**
	 * 添加消息并自动滚动到底部，适合没有设置发送/接收模板的情况下使用
	 */
	this.appendItem=function(item){
		if(!item)return;
		this.container.appendChild(item);
		scrollToBottom();
		this.offset=this.container.childElementCount;
	};
	/**
	 * 批量添加消息并自动滚动到底部
	 */
	this.multipleAppend=function(items){
		for (var i = 0; i < items.length; i++) {
			this.container.appendChild(items[i]);
		}
		scrollToBottom();
		this.offset=this.container.childElementCount;
	};
	/**
	 * 仅实现视觉效果，需要调用IM才能发送消息
	 */
	this.sendMessage=function(item){
		var msgItem=this.sendTemplate.cloneNode(true);
		msgItem.querySelector('.right-arrow').appendChild(item);
		return msgItem;
	};
	/**
	 * 消息由JSBridge传入，仅显示消息详情
	 */
	this.receivedMessage=function(item){
		var msgItem=this.receivedTemplate.cloneNode(true);
		msgItem.querySelector('.left-arrow').appendChild(item);
		return msgItem;
	};
	/**
	 * 取出保存在本地数据库已显示的消息数目{offset}之前的{pageSize}条记录
	 */
	this.notifyUpdate=function(pageSize){
		if(!pageSize)pageSize=10;
		readMessage({
			'range':[this.offset,this.offset+pageSize],
			'callback':function(result){
				if(result){
					if(result.msgType!=1){
						readFile(result.msgFileUrl,function(file){
							if(!file){
								this.prependItem(this.createMessage(result));
								return;
								};
							var blob=dataURLtoBlob(file.dataUrl);
							result.msgFileUrl=window.URL.createObjectURL(blob);
							this.prependItem(this.createMessage(result));
						}.bind(this));
					}
					else this.prependItem(this.createMessage(result));
				}
				else mui.toast("没有更多消息");
			}.bind(this)
		});
	}
	
	function CreatingTimeFormatInfo(time)
	{
		var text=new Date(time).Format('yyyy-MM-dd hh:mm:ss');
		
		this.Year=text.substr(0,4);
		this.Month=text.substr(5,2);
		this.Day=text.substr(8,2);
		
		this.Hour=text.substr(11,2);
		this.Min=text.substr(14,2);
		this.Second=text.substr(17);
		
		this.unitTimes=[this.Year,this.Month,this.Day,this.Hour,this.Min,this.Second];
		
		this.toString=function()
		{
			return text;
		}
	}
	function CreatingTimeCompartor(timeAccuracy,startTimeInfo)
	{
		this.timeAccuracy=timeAccuracy;
		var lastInfo=startTimeInfo;
		
		this.compare=function(info)
		{
			if(null==lastInfo)
			{
				lastInfo=info;
			}
			else
			{
				if(timeAccuracy>=this.unitTimes.length)
				{
					lastInfo=info;
					return lastInfo.toString();
				}
				for(var i=0;i<this.timeAccuracy;++i)
				{
					if(info.unitTimes[i]!=lastInfo.unitTimes[i])
					{
						lastInfo=info;
						return lastInfo.toString();
					}
				}
			}
			return null;
		}
	}
	
	var timeCompartor=new CreatingTimeCompartor
	(
		4,
		new CreatingTimeFormatInfo(new Date().getTime())
	);
	
	/*格式化li:before文本信息，返回null不显示*/
	this.getCreatingTimeText=function(msgItem,msg)
	{
		//精确到分钟
		/*
		var createdInfo=new CreatingTimeFormatInfo(parseInt(msg.msgDateCreated));
		return timeCompartor.compare(createdInfo);
		*/
		
		//全部显示
		return new Date(parseInt(msg.msgDateCreated)).Format("yyyy-MM-dd hh:mm:ss");
	}
}
