mui.init();
var args = GetRequest();
var base = new BASE();
var data = {},
	url;
/**
 * 支付类型
 */
var PayType = {
	NULL: 0, //无
	UNKNOW: 1, //其他
	CONSULT: 2, //咨询
	JOIN_CLASS: 3, //加入课堂
	RECHARGE: 4, //充值
	MALL: 5 //商城商品
};
window.onpageshow = function() {
	args = GetRequest();
	base = new BASE();
	data = {}, url;
	Refresh();
};

mui.plusReady(function() {
	plus.webview.create('pay.html');
});

function Refresh() {
	if(args.orderId) {
		url = base.getBASEURL() + "appapi/1/pay/order/detail?tradeNo=" + args.orderId;
		data.type = 0; //表示订单ID已存在
	} else if(args.classId) {
		url = base.getBASEURL() + "appapi/1/class/detail?id=" + args.classId;
		data.classId = args.classId;
		data.payWay = 3;
		data.type = PayType.JOIN_CLASS;
	} else if(args.doctorId) {
		data.consultId = args.consultId;
		data.consultUserId = args.doctorId;
		data.type = PayType.CONSULT;
		data.fee = args.fee;
		Recharge(args.fee);
	} else if(args.type) {
		data.type = args.type;
		if(args.type == PayType.MALL) {
			data.mallOrderId = args.sn;
			submitOrder();
		}
		data.type = args.type;
		data.fee = args.fee;
		Recharge(args.fee);
	} else {
		data.payWay = 3;
		data.type = paytype.UNKNOWN;
	}
	if(url) loadData(url);
}

function Recharge(fee) {
	if(data.consultUserId) {
		document.getElementById('lesson').innerText = '咨询转账';
		document.getElementById('type').innerText = '咨询费用';
		getUserName(data.consultUserId);
	} else if(data.type == PayType.MALL) {
		document.getElementById('lesson').innerText = '购买商品';
		document.getElementById('type').innerText = '商品购买';
		document.getElementById('charge').innerText = '国浩中医';
	} else if(data.type == PayType.RECHARGE) {
		document.getElementById('lesson').innerText = '账号充值';
		document.getElementById('type').innerText = '会员充值';
		document.getElementById('charge').innerText = '国浩中医';
	}
	document.getElementById('unpaid').style.display = 'block';
	document.getElementById('fee').innerText = fee;
	document.getElementById('textNote').style.display = 'none';
	var go = document.getElementById('go');
	go.style.display = 'table';
	go.innerText = '确认订单';
	go.onclick = function() {
		if(data.type != PayType.RECHARGE) {
			submitOrder();
		} else {
			submitOrderWithRecharge();
		}
	};
}

function getUserName(userId) {
	var url = base.getBASEURL() + "appapi/1/user/profile?userId=" + userId;
	mui.ajax(url, {
		success: function(response) {
			if(response.success) {
				document.getElementById('charge').innerText = response.obj.realName;
			}
		},
		error: function(response) {

		}
	});
}

function loadData(url) {
	mui.ajax(url, {
		success: function(response) {
			if(!response.success) return mui.toast(response.msg);
			switch(data.type) {
				case 0:
					var detail = JSON.parse(response.obj.detail);
					var payWayAlias = ['微信', '支付宝', '余额', '其他'];
					document.getElementById('paid').style.display = 'block';
					document.getElementById('orderId').innerText = response.obj.tradeNo;
					document.getElementById('account').innerText = detail.body;
					document.getElementById('amount').innerText = response.obj.fee;
					document.getElementById('payWay').innerText = payWayAlias[response.obj.payWay - 1 > 0 ? response.obj.payWay - 1 : 3];
					document.getElementById('createTime').innerText = new Date(response.obj.createAt).Format('yyyy-MM-dd hh:mm:ss');
					var status = document.getElementById('status');
					var go = document.getElementById('go');
					if(response.obj.payStatus == 1) {
						status.innerText = '已付款';
						go.style.display = 'table';

						var detailObj = JSON.parse(response.obj.detail);
						console.log(detailObj);

						switch(detail.businessType) {
							case 3:
								var classId = detailObj.classId;
								go.innerText = '进入课堂';
								go.onclick = function() {
									openWindow('IM.html?classId=' + classId);
								}
								break;
							case 2:
								var consultId = detailObj.consultId;
								var doctorId = detailObj.bId;

								go.onclick = function() {
									if(consultId) {
										openWindow('IM.html?consultId=' + consultId + '#' + doctorId);
									} else {
										_jumpIM(doctorId);
									}
								}

								go.innerText = '开始咨询';
								break;
							case 1:
								go.innerText = '发布招标';

								go.onclick = function() {
									var succourId = response.obj.businessId;
									openWindow('EmergencyCenter_Answer.html?succourId=' + succourId);
								}

								break;
							default:
								go.style.display = 'none';
						}

					} else if(response.obj.payStatus == 0) {
						status.innerText = '等待付款';
						go.style.display = 'table';
						go.innerText = '立即支付';
						go.onclick = function() {
							if(detail.businessType == 4) {
								openWindow('pay.html?orderId=' + response.obj.tradeNo + '&recharge=1');
							} else {
								openWindow('pay.html?orderId=' + response.obj.tradeNo);
							}

						};
					} else {
						status.innerText = '已关闭';
						go.style.display = 'none';
						go.onclick = function() {
							openWindow('pay.html?orderId=' + response.obj.tradeNo)
						};
					}
					break;
				case 1:
					break;
				case 2:
					break;
				case 3:
					document.getElementById('unpaid').style.display = 'block';
					document.getElementById('lesson').innerText = '“' + response.obj.title + "”";
					document.getElementById('type').innerText = '会员费';
					document.getElementById('charge').innerText = response.obj.realName;
					document.getElementById('fee').innerText = response.obj.price;
					var go = document.getElementById('go');
					go.style.display = 'table';
					go.innerText = '确认订单';
					go.onclick = function() {
						submitOrder()
					};
					break;
				default:
					mui.toast(response.msg)
					mui.back();
			}
		},
		error: function(response) {
			mui.toast('加载商品信息失败：' + JSON.stringify(response));
			mui.back();
		}
	});
}

function submitOrder() {
	var orderUrl = base.getBASEURL() + 'appapi/1/pay/preCreate';
	if(data.type == 1) data.fee = document.getElementById('fee').value;
	mui.ajax(orderUrl, {
		type: 'POST',
		data: data,
		success: function(response) {
			if(response.success) {
				history.replaceState({}, '订单详情', 'order.html?orderId=' + response.obj.tradeNo);
				openWindow('pay.html?orderId=' + response.obj.tradeNo);
			} else mui.toast(response.msg);
		},
		error: function(response) {
			mui.toast('创建订单失败：' + response.response);
			console.info(response);
		}
	});
}

function submitOrderWithRecharge() {
	var orderUrl = base.getBASEURL() + 'appapi/1/pay/preCreate';
	if(data.type == 1) data.fee = document.getElementById('fee').value;
	mui.ajax(orderUrl, {
		type: 'POST',
		data: data,
		success: function(response) {
			if(response.success) {
				history.replaceState({}, '订单详情', 'order.html?orderId=' + response.obj.tradeNo + '&recharge=1');
				openWindow('pay.html?orderId=' + response.obj.tradeNo + '&recharge=1');
			} else mui.toast(response.msg);
		},
		error: function(response) {
			mui.toast('创建订单失败：' + response.response);
			console.info(response);
		}
	});
}

function _jumpIM(doctorId) {
	var url = base.getBASEURL() + "appapi/1/consult/startConsult";
	mui.ajax(
		url, {
			type: "POST",
			data: {
				doctorId: doctorId,
				consultType: 3
			},
			success: function(response) {
				if(response.success) {
					if(response.errorCode == 1001) {
						var consultId = response.obj.consultId;
						if(base.getRUMTIME() == 1) {
							var notiClass = plus.ios.importClass("NSNotificationCenter");
							notiClass.defaultCenter().postNotificationNameobject("IM", consultId + ':' + doctorId + ':1');
						} else {
							openWindow('IM.html?consultId=' + consultId + '#' + doctorId);
						}
					} else {
						mui.toast(response.msg);
					}

				} else {
					mui.toast(response.msg);
				}
			},
			error: function(response) {
				mui.toast('发送失败');
			}
		}
	);
}