/**
 * 多媒体管理器
 */
var MediaManager = {
	/**
	 * 七牛上传器
	 */
	qiniuUploader: null,
	/**
	 * 上传控件
	 */
	uploadCtrl: document.getElementById("txtUpload"),
	/**
	 * 已上传图片
	 */
	arrUploadedImg: [],
	/**
	 * 初始化七牛令牌
	 */
	initQiniuToken: function() {
		var token_url = new BASE().getBASEURL() + "appapi/1/qiniu/upload/token.do";
		mui.ajax(token_url, {
			success: function(response) {
				if(response.success) {
					MediaManager.initQiniu(response.msg);
				} else {
					mui.toast(response.msg);
				}
			},
			error: function(response) {
				console.info(response);
			}
		});
	},
	/**
	 * 初始化七牛
	 * 
	 * @param {Object} qiniuToken 七牛令牌
	 */
	initQiniu: function(qiniuToken) {
		MediaManager.qiniuUploader = Qiniu.uploader({
			runtimes: 'html5,flash,html4',
			browse_button: 'btnUpload',
			container: 'container',
			drop_element: 'container',
			max_file_size: '100mb',
			flash_swf_url: 'js/plupload/Moxie.swf',
			dragdrop: false,
			chunk_size: '4mb',
			uptoken: qiniuToken,
			multi_selection: false,
			unique_names: true, // 默认 false，key为文件名。若开启该选项，SDK为自动生成上传成功后的key（文件名）。
			domain: 'http://media.guohaozhongyi.com/',
			auto_start: true,
			init: {}
		});
		MediaManager.qiniuUploader.bind('FilesAdded', function(up, files) {
			var attachmentList = document.getElementById('attachmemtList');
			var count = attachmentList.childElementCount;
			var child = attachmentList.childNodes[count - 1];
			child.id = files[0].id;
			MediaManager.uploadCtrl.value = '';
			mui.toast('正在上传附件...请稍等');
		});
		MediaManager.qiniuUploader.bind('FileUploaded', function(up, file, info) {
			var attachmentList = document.getElementById('attachmemtList');
			var imgUrl = "http://media.guohaozhongyi.com/" + file.target_name;
			var count = attachmentList.childElementCount;
			attachmentList.childNodes[count - 1].childNodes[0].setAttribute('src', imgUrl);
			MediaManager.arrUploadedImg.push(imgUrl);
			mui.toast('附件上传完毕！请继续！');
		});
	},
	/**
	 * 上传
	 */
	upload: function() {
		var attachmentList = document.getElementById('attachmemtList');
		if(attachmentList.childElementCount > 5) {
			return mui.toast('附件最多只能有5个！');
		}
		MediaManager.uploadCtrl.click();
	},
	/**
	 * 上传文件
	 * 
	 */
	uploadFile: function() {
		var fileName = MediaManager.uploadCtrl.value.toLowerCase();
		if(fileName) {
			var attachmentList = document.getElementById('attachmemtList');
			if(attachmentList.childElementCount > 5) return mui.toast('附件最多只能有5个！');
			var attachment = MediaManager.uploadCtrl.files[0];
			var li = document.createElement('li');
			li.setAttribute('onclick', 'MediaManager.show(this);');
			//	alert(fileName);
			var imageReg = new RegExp("(.jpg|.png|.bmp|.jpeg)$");
			var videoReg = new RegExp("(.mp4|.flv|.mov)$");
			var voiceReg = new RegExp("(.mp3|.wav|.amr)$");
			if(imageReg.test(fileName)) {
				var img = document.createElement('img');
				img.src = window.URL.createObjectURL(attachment);
				img.style.height = '100%';
				img.style.width = 'auto';
				li.appendChild(img);
			} else if(videoReg.test(fileName)) {
				var video = document.createElement('video');
				video.src = window.URL.createObjectURL(attachment);
				video.style.height = '100%';
				li.appendChild(video);
			} else if(voiceReg.test(fileName)) {
				var audio = document.createElement('audio');
				li.classList.add('music');
				audio.src = window.URL.createObjectURL(attachment);
				audio.style.height = '100%';
				li.appendChild(audio);
			} else return mui.toast('类型不支持或文件名太长');
			attachmentList.insertBefore(li, attachmentList.lastElementChild);
			MediaManager.qiniuUploader.addFile(MediaManager.uploadCtrl.files[0]);
		}
	},
	/**
	 * 显示多媒体
	 * 
	 * @param {Object} li 
	 */
	show: function(li) {
	/*	var modal = new Modal('#show');
		var child = li.firstElementChild;
		if(child instanceof HTMLAudioElement) {
			var music = document.getElementById('music');
			music.src = child.src;
			return music.play(); //如果是音频就直接播放
		}
		modal.content.appendChild(child.cloneNode());
		modal.body.onclick = function() {
			modal.hide();
			modal.content.removeChild(modal.content.firstElementChild);
		};
		modal.body.querySelector('#delete').onclick = function() {
			MediaManager.removeImg(li.id);
			MediaManager.qiniuUploader.removeFile(MediaManager.qiniuUploader.getFile(li.id));
			li.remove();
		}.bind(li);
		modal.show();
		document.getElementById('show').style.top = "0";
		document.getElementById('show').querySelector('.content').style.width = "100%";
		document.getElementById('show').querySelector('.content').childNodes[0].style.width = "100%";*/
		
		MUIPopover.autoPopover
		(
			{
				domSource:li
			}
		);
	},
	/**
	 * Clear Img
	 * 
	 * @param {Object} id
	 */
	removeImg: function(id) {
		var newArrImg = [];
		for(var i = 0; i < MediaManager.arrUploadedImg.length; i++) {
			if(MediaManager.arrUploadedImg[i].indexOf(id) == -1) {
				newArrImg.push(MediaManager.arrUploadedImg[i]);
			}
		}
		MediaManager.arrUploadedImg = newArrImg;
	}
};
/**
 * 商品管理器
 */
var ProductManager = {
	/**
	 * 基础库
	 */
	base: new BASE(),
	/**
	 * 商城令牌
	 */
	mallToken: '',
	/**
	 * 初始化商城令牌
	 */
	initMallToken: function() {
		var url = this.base.getBASEURL() + "appapi/1/user/getMallToken";
		mui.ajax(url, {
			data: {},
			type: "POST",
			success: function(response) {
				if(response.success) {
					ProductManager.mallToken = response.msg;
				} else {
					mui.toast(response.msg);
				}
			},
			error: function(response) {
				mui.toast("网络出错：" + JSON.stringify(response));
			}
		});
	},
	/**
	 * 获取商品分类
	 */
	getGoodsType: function() {
		mui.ajax(this.base.getMallUrl() + "api/goodsType.do", {
			data: {
				tk: ProductManager.mallToken
			},
			type: "POST",
			success: function(response) {
				if(response.result == 1) {
					var json = eval(response.data);
					if(json) {
						cityPicker = new mui.PopPicker({
							layer: 3
						});
						cityPicker.setData(json);
						cityPicker.show(function(items) {
							if(items[2].text) {
								document.getElementById('typeName').value = items[2].text;
								document.getElementById('typeId').value = items[2].value;
							} else if(items[1].text) {
								document.getElementById('typeName').value = items[1].text;
								document.getElementById('typeId').value = items[1].value;
							} else {
								document.getElementById('typeName').value = items[0].text;
								document.getElementById('typeId').value = items[0].value;
							}
						});
					}
				} else {
					mui.toast(response.message);
				}
			},
			error: function(response) {
				mui.toast("网络出错：" + JSON.stringify(response));
			}
		});
	},
	/**
	 * 获取商铺分组
	 */
	getStoreCategory: function() {
		mui.ajax(this.base.getMallUrl() + "api/storeCategory.do", {
			data: {
				tk: ProductManager.mallToken
			},
			type: "POST",
			success: function(response) {
				if(response.result == 1) {
					var json = eval(response.data);
					if(json) {
						cityPicker = new mui.PopPicker({
							layer: 2
						});
						cityPicker.setData(json);
						cityPicker.show(function(items) {
							if(items[1].text) {
								document.getElementById('catName').value = items[1].text;
								document.getElementById('catId').value = items[1].value;
							} else if(items[0].value) {
								document.getElementById('catName').value = items[0].text;
								document.getElementById('catId').value = items[0].value;
							} else {
								document.getElementById('catName').value = '默认';
								document.getElementById('catId').value = 0;
							}
						});
					}
				} else {
					mui.toast(response.message);
				}
			},
			error: function(response) {
				mui.toast("网络出错：" + JSON.stringify(response));
			}
		});
	},
	/**
	 * 生成描述图片Html
	 */
	generatePicHtml: function(arrPics) {
		var arrHtml = [];
		for(var i = 0; i < arrPics.length; i++) {
			arrHtml.push("<img src='" + arrPics[i] + "' alt='产品图' />");
		}
		return arrHtml.join('<br />');
	},
	/**
	 * 保存商品
	 */
	save: function() {
		var name = document.getElementById("title").value;
		var typeId = document.getElementById("typeId").value;
		var catId = document.getElementById("catId").value;
		var price = document.getElementById("price").value;
		var intro = document.getElementById("intro").value;
		var weight = document.getElementById("weight").value;
		var fee = document.getElementById("fee").value;
		var amount = document.getElementById("amount").value;
		var transferType = 1; //0买家承担，1卖家承担
		var pic = ""; //图片
		var pics = ""; //图片串
		if(!name) {
			mui.toast("商品名称不能为空，请填写");
			return;
		}
		if(!typeId) {
			mui.toast("商品分类不能为空，请选择");
			return;
		}
		if(!price) {
			mui.toast("商品价格不能为空，请填写");
			return;
		}
		if(!intro) {
			mui.toast("商品描述不能为空，请填写");
			return;
		}
		if(!amount) {
			mui.toast("库存不能为空，请填写");
			return;
		}
		if(fee && fee > 0) {
			transferType = 0;
		}
		if(MediaManager.arrUploadedImg.length == 0) {
			mui.toast("商品图片不能为空，请上传");
			return;
		}
		pic = MediaManager.arrUploadedImg[0];
		intro += "<div class='photos'>" + 　this.generatePicHtml(MediaManager.arrUploadedImg) + "</div>";
		mui.ajax(this.base.getMallUrl() + "api/add.do", {
			data: {
				tk: ProductManager.mallToken,
				name: name,
				price: price,
				intro: intro,
				cat_id: typeId,
				store_cat_id: catId ? catId : 0,
				market_enable: 1, //上架
				cost: price,
				mktprice: price,
				weight: weight ? weight : 1,
				goods_transfee_charge: transferType,
				store: amount, //库存
				thumbnail: pic,
				big: pic,
				small: pic,
				original: pic,
				pics: MediaManager.arrUploadedImg.join('|')
			},
			type: "POST",
			success: function(response) {
				if(response.result == 1) {
					mui.toast("保存成功!");
					mui.back();
				} else {
					mui.toast(response.message);
				}
			},
			error: function(response) {
				mui.toast("网络出错：" + JSON.stringify(response));
			}
		});
	}
};

/**
 * 初始化视图
 */
function initView() {

	//分类输入框点击事件监听
	document.getElementById("typeName").addEventListener('tap', function() {
		ProductManager.getGoodsType();
	});

	//商铺分组输入框点击事件监听
	document.getElementById("catName").addEventListener('tap', function() {
		ProductManager.getStoreCategory();
	});

	//上传图标点击事件监听
	document.getElementById("btnAdd").addEventListener('tap', function() {
		MediaManager.upload();
	});

	//上传控件内容变化事件监听
	document.getElementById("txtUpload").addEventListener('change', function(event) {
		//	alert(event.target.files[0].name);
		document.getElementById('container').querySelector('input[type=file]').setAttribute('accept', 'image/*,video/*,audio/*');
		MediaManager.uploadFile();
	});

	//保存按钮点击事件
	document.getElementById("btnSave").addEventListener("tap", function() {
		ProductManager.save();
	});

}

/**
 * 初始化数据
 */
function initData() {
	//初始化七牛上传
	MediaManager.initQiniuToken();
	//初始化商城令牌
	ProductManager.initMallToken();

}

(function($, doc) {
	$.init();
	$.ready(function() {
		//初始化视图
		initView();
		//初始化数据
		initData();

	});
})(mui, document);