var ProductMgr = {
	/**
	 * 商城令牌
	 */
	mallToken: '',

	apiUrl: new BASE().getBASEURL(),
	mallUrl: new BASE().getMallUrl(),

	modal: new Modal('#waiting'),

	sellingProduct: null,

	prepareProduct: null,

	/**
	 * 初始化商城令牌
	 */
	initMallToken: function() {

		ProductMgr.modal.show();

		var url = ProductMgr.apiUrl + "/appapi/1/user/getMallToken";
		mui.ajax(url, {
			data: {},
			type: "POST",
			success: function(response) {
				if(response.success) {

					ProductMgr.mallToken = response.msg;

					ProductMgr.getSellingProduct();
					ProductMgr.getPrepareProduct();

				} else {
					mui.toast(response.msg);
				}
			},
			error: function(response) {
				mui.toast("网络出错：" + JSON.stringify(response));
			}
		});
	},

	/**
	 * 初始化控件
	 */
	initCtrl: function() {
		ProductMgr.sellingProduct = new AdvancedList('#sellingProduct');
		ProductMgr.sellingProduct.setItemTemplate('#sellingProduct > li:first-child');
		ProductMgr.sellingProduct.onCreateItem = function(data, item) {
			item.style.display='block';
			item.firstElementChild.id = data.goods_id;
			item.querySelector('.ptitle').innerHTML = data.name;
			item.querySelector('.thumbnail').src = data.thumbnail;
			item.querySelector('.price').innerHTML = "￥" + data.price;
			item.querySelector('.amount').innerHTML = data.buy_count;
		};

		ProductMgr.prepareProduct = new AdvancedList('#prepareProduct');
		ProductMgr.prepareProduct.setItemTemplate('#prepareProduct > li:first-child');
		ProductMgr.prepareProduct.onCreateItem = function(data, item) {
			item.style.display='block';
			item.firstElementChild.id = data.goods_id;
			item.querySelector('.ptitle').innerHTML = data.name;
			item.querySelector('.thumbnail').src = data.thumbnail;
			item.querySelector('.price').innerHTML = "￥" + data.price;
			item.querySelector('.amount').innerHTML = data.buy_count;
		};

		ProductMgr.sellingProduct.clearAll();
		ProductMgr.prepareProduct.clearAll();

	},

	/**
	 * 获取出售中产品
	 */
	getSellingProduct: function() {
		var url = ProductMgr.mallUrl + 'api/productList.do';
		mui.ajax(url, {
			data: {
				tk: ProductMgr.mallToken,
				page: 1,
				pageSize: 100,
				marketEnable: 1
			},
			type: "POST",
			success: function(response) {
				if(response.result == 1) {
					ProductMgr.sellingProduct.multipleAppend(response.data.result);
					ProductMgr.modal.hide();
				} else {
					mui.toast(response.message);
					if(response.message.indexOf('店铺未开通') > -1) {
						location.href = 'mine_OpenMall.html';
					}
				}
			},
			error: function(response) {
				mui.toast("网络出错：" + JSON.stringify(response));
			}
		});
	},

	/**
	 * 获取下架产品
	 */
	getPrepareProduct: function() {
		var url = ProductMgr.mallUrl + 'api/productList.do';
		mui.ajax(url, {
			data: {
				tk: ProductMgr.mallToken,
				page: 1,
				pageSize: 100,
				marketEnable: 0
			},
			type: "POST",
			success: function(response) {
				if(response.result == 1) {
					ProductMgr.prepareProduct.multipleAppend(response.data.result);
				} else {
					mui.toast(response.message);
				}
			},
			error: function(response) {
				mui.toast("网络出错：" + JSON.stringify(response));
			}
		});
	},

	/**
	 * 下架产品
	 * 
	 * @param {Object} that
	 */
	closeProduct: function(that) {
		mui.confirm('您确认要下架产品 吗？', '温馨提示', null, function(e) {
			if(e.index == 1) {
				var id = that.previousElementSibling.id;
				var url = ProductMgr.mallUrl + 'api/under-goods.do';
				mui.ajax(url, {
					data: {
						tk: ProductMgr.mallToken,
						goods_id: id
					},
					type: "POST",
					success: function(response) {
						if(response.result == 1) {
							location.reload();
						} else {
							mui.toast(response.message);
						}
					},
					error: function(response) {
						mui.toast("网络出错：" + JSON.stringify(response));
					}
				});
			}
		});
	},
	
	
	findTag:function(node,tagName)
	{
		tagName=tagName.toUpperCase();
		var parent=node;
		while(parent)
		{
			if(parent.tagName.toUpperCase()==tagName)
			{
				return parent;
			}
			parent=parent.parentNode;
		}
		
		return null;
	},
	
	findPrevSbiling:function(node,tagName)
	{
		tagName=tagName.toUpperCase();
		var prev=node;
		while(prev)
		{
			if(prev.tagName.toUpperCase()==tagName)
			{
				return prev;
			}
			prev=prev.previousElementSibling;
		}
		
		return null;
	},

	/**
	 * 删除产品
	 * 
	 * @param {Object} that
	 */
	delProduct: function(that) {
	//	var id = that.previousElementSibling.id;
		mui.confirm('您确认要删除产品 吗？', '温馨提示', null, function(e) {
			if(e.index == 1) {
				var a=ProductMgr.findPrevSbiling(that,'a');
				var id=NaN;
				if(a)
				{
					id=parseInt(a.getAttribute('id'));
					console.error('没有包含id的元素');
				}
				
				if(isNaN(id))
				{
					mui.toast('回收失败');
					return;
				}
				
				var url = ProductMgr.mallUrl + 'api/delete-goods.do';
				mui.ajax(url, {
					data: {
						tk: ProductMgr.mallToken,
						goods_id: id
					},
					type: "POST",
					success: function(response) {
						if(response.result == 1) {
							location.reload();
						} else {
							mui.toast(response.message);
						}
					},
					error: function(response) {
						mui.toast("网络出错：" + JSON.stringify(response));
					}
				});
			}
		});
	},

	/**
	 * 上架
	 * 
	 * @param {Object} that
	 */
	openProduct: function(that) {
		var id = that.previousElementSibling.id;
		var url = ProductMgr.mallUrl + 'api/up-goods.do';
		mui.ajax(url, {
			data: {
				tk: ProductMgr.mallToken,
				goods_id: id
			},
			type: "POST",
			success: function(response) {
				if(response.result == 1) {
					mui.toast("上架成功");
					location.reload();
				} else {
					mui.toast(response.message);
				}
			},
			error: function(response) {
				mui.toast("网络出错：" + JSON.stringify(response));
			}
		});
	}
};

(function($, doc) {
	$.init();

	$.ready(function() {

		ProductMgr.initCtrl();
		ProductMgr.initMallToken();

	});
})(mui, document);