function ProgressBar(divProgress, width, height, borderwidth, frontground, background) {
	var progress = divProgress;
	var progressValue = 0.0;

	if(width) {
		progress.style.width = parseInt(width) + "px";
	}

	if(height) {
		progress.style.height = parseInt(height) + "px";
	}

	if(divProgress.classList.contains('circle-wrapper')) {

		if(!frontground) {
			frontground = '-webkit-gradient(linear,34% 0%, 0% 100%, from(#20D62C), to(#389900), color-stop(0.5,#39BD00))';
		}
		if(!background) {
			background = '#ccc';
		}
		var left = progress.querySelector('.left');
		var right = progress.querySelector('.right');

		right.style.clip = 'rect(0px, ' + width + 'px, ' + width + 'px, ' + (width / 2) + 'px)';
		left.style.clip = 'rect(0px, ' + (width / 2) + 'px, ' + width + 'px, 0px)';

		this.setProgress = function(value) {
			if(value < 0.0) {
				value = 0.0;
			}
			if(value > 1.0) {
				value = 1.0;
			}
			progressValue = value;

			progress.classList.remove('fail');
			var againBtn=progress.querySelector('button');
			if(againBtn)
			{
				againBtn.parentNode.removeChild(againBtn);
			}

			var left = progress.querySelector('.left');
			var right = progress.querySelector('.right');

			var num = progress.querySelector('.num');
			var circle = progress.querySelector('.circle');
			num.style.width = (width - borderwidth) + 'px';
			num.style.height = (width - borderwidth) + 'px';
			num.style.top = borderwidth / 2 + 'px';
			num.style.left = borderwidth / 2 + 'px';
			num.style.lineHeight = (width - borderwidth) + 'px';

			progress.style.width = width + 'px';
			progress.style.height = height + 'px';
			left.style.width = width + 'px';
			left.style.height = height + 'px';
			right.style.width = width + 'px';
			right.style.height = height + 'px';
			circle.style.width = width + 'px';
			circle.style.height = height + 'px';
			circle.style.removeProperty('display');
			circle.style.background = frontground;

			if(value <= 0.5) {
				left.style.removeProperty('-webkit-transform');
				left.style.removeProperty('-ms-transform');
				left.style.removeProperty('-moz-transform');

				left.style.background = background;
				right.style.background = background;

				left.style.zIndex = 61;
				right.style.zIndex = 60;

				var deg = "rotate(" + ((value * 100 * 3.6)) + "deg)";
				right.style.webkitTransform = deg;
				right.style.msTransform = deg;
				right.style.MozTransform = deg;
			} else {
				right.style.removeProperty('-webkit-transform');
				right.style.removeProperty('-ms-transform');
				right.style.removeProperty('-moz-transform');

				left.style.background = background;
				right.style.background = frontground;
				right.style.zIndex = 61;
				left.style.zIndex = 60;

				var deg = "rotate(" + ((value - 0.5) * 100 * 3.6) + "deg)";
				left.style.webkitTransform = deg;
				left.style.msTransform = deg;
				left.style.MozTransform = deg;
			}

			this.setText(parseInt(value * 100) + '%');
		};

		this.setText = function(text) {
			progress.querySelector('.num').innerText = text;
		};

		this.tryAgain = function(fxAgainBack, text) {
			var bar = this;
			var btnWrapper = document.createElement('button');
			btnWrapper.style.position = 'absolute';
			var circle = progress.querySelector('.circle');
			btnWrapper.style.left = circle.style.left;
			btnWrapper.style.top = circle.style.top;
			btnWrapper.style.width = circle.style.width;
			btnWrapper.style.height = circle.style.height;
			btnWrapper.style.lineHeight = btnWrapper.style.height;
			btnWrapper.style.textAlign = 'center';
			//	btnWrapper.style.borderRadius = '50%';
			btnWrapper.innerText = text ? text : '重发';
			btnWrapper.style.fontSize = '1.0em';
			//	btnWrapper.style.border = 'solid 1px black';
			circle.parentNode.appendChild(btnWrapper);
			circle.style.display = 'none';

			if(fxAgainBack) {
				btnWrapper.onclick = function() {
					fxAgainBack(bar);
				}
			}
		};

		this.failure = function() {
			this.setProgress(0.0);
			progress.classList.add('fail');
			this.setText('失败');
		};

		this.successfully = function() {
			progress.classList.remove('fail');
			this.setProgress(1.0);
		};

	} else {
		this.setProgress = function(value) {
			if(value < 0.0) {
				value = 0.0;
			}
			if(value > 1.0) {
				value = 1.0;
			}
			var againBtn=progress.querySelector('button');
			if(againBtn)
			{
				againBtn.parentNode.removeChild(againBtn);
			}
			progressValue = value;
			progress.querySelector('span').innerText = Math.round(value * 100) + "%";
			progress.querySelector('.progress-bar').style.removeProperty('display');
			progress.querySelector('.progress-bar').style.width = Math.round(value * 100) + "%";
			if(value >= 0.5) {
				progress.querySelector('span').classList.add('p50');
			} else {
				progress.querySelector('span').classList.remove('p50');
			}
		};

		this.setText = function(text) {
			progress.querySelector('span').innerText = text;
		};

		this.failure = function() {
			this.setText('上传失败');
			progress.classList.add('fail');
			progress.querySelector('.progress-bar').style.removeProperty('width');
		};

		this.successfully = function() {
			this.setText('上传完毕');
		};

		this.tryAgain = function(fxAgainBack, text) {
			var bar = this;
			var btnWrapper = document.createElement('button');
			var progressBar = progress.querySelector('.progress-bar');
			console.log(progressBar);
			btnWrapper.style.width = progressBar.style.width;
			btnWrapper.style.height = '100%';
			btnWrapper.style.textAlign = 'center';
			btnWrapper.innerText = text ? text : '重发';
			btnWrapper.style.fontSize = '1.0em';

			progressBar.parentNode.appendChild(btnWrapper);
			progressBar.style.display = 'none';

			if(fxAgainBack) {
				btnWrapper.onclick = function() {
					fxAgainBack(bar);
				}
			}
		};
	}

	this.replaceWith = function(domObject) {
		if(progress) {
			progress.parentNode.replaceChild(domObject, progress);
		}
	};

	this.getProgress = function() {
		return progressValue;
	};

	this.detach = function() {
		if(progress) {
			progress.parentNode.removeChild(progress);
			progress = null;
		}
	};

	this.getParenNode = function() {
		return progress ? progress.parentNode : null;
	};

	this.setProgress(progressValue);
};

ProgressBar.createTemplate = function(parent) {
	var progress = document.createElement('div');
	progress.classList.add('progress');
	progress.innerHTML = "<div class=\"progress-bar\"><span>99%</span></div>";
	if(parent) {
		parent.appendChild(progress);
	}
	return progress;
};

ProgressBar.createCircleTemplate = function() {
	var div = document.createElement('div');
	div.classList.add('circle-wrapper');
	div.innerHTML =
		"<div class=\"circle\">" +
		"<div class=\"right\"></div>" +
		"<div class=\"percent left\"></div>" +
		"<div class=\"num\">0%</div>" +
		"</div>";
	return div;
}

ProgressBar.createWrapperTemplate = function(parent, text) {
	var bar = ProgressBar.createTemplate();
	var wrapper = document.createElement('div');
	wrapper.classList.add('progress-wrapper');
	bar.classList.add('marginTop');
	var remark = document.createElement('div');
	remark.innerText = text ? text : "";
	wrapper.appendChild(bar);
	wrapper.appendChild(remark);

	if(parent) {
		parent.appendChild(wrapper);
	}
	return wrapper;
}

ProgressBar.createProgressBarWrapper = function(parent, wrapper, text) {
	if(!wrapper) {
		wrapper = ProgressBar.createWrapperTemplate(parent, text);
	}

	var bar = new ProgressBar(wrapper.querySelector('.progress'));
	return bar;
};